searchNodes=[{"doc":"Mimic is a library that simplifies the usage of mocks in Elixir.Mimic is mostly API compatible with mox but doesn't require explicit contract checking with behaviours. It's also faster. You're welcome.Mimic works by copying your module out of the way and replacing it with one of it's own which can delegate calls back to the original or to a mock function as required.In order to prepare a module for mocking you must call copy/1 with the module as an argument. We suggest that you do this in your test/test_helper.exs:Mimic.copy(Calculator) ExUnit.start()Importantly calling copy/1 will not change the behaviour of the module. When writing tests you can then use stub/3 or expect/3 to add mocks and assertions.Multi-process collaborationMimic supports multi-process collaboration via two mechanisms:Explicit allows.Global mode.Using explicit allows is generally preferred as these stubs can be run concurrently, whereas global mode tests must be run exclusively.Explicit allowsUsing allow/3 you can give other processes permission to use stubs and expectations from where they were not defined.test &quot;invokes add from a process&quot; do Caculator |&gt; expect(:add, fn x, y -&gt; x + y end) parent_pid = self() spawn_link(fn -&gt; Calculator |&gt; allow(parent_pid, self()) assert Calculator.add(2, 3) == 5 send parent_pid, :ok end) assert_receive :ok endIf you are using Task the expectations and stubs are automatically allowedGlobal modeWhen set in global mode any process is able to call the stubs and expectations defined in your tests.Warning: If using global mode you should remove async: true from your testsEnable global mode using set_mimic_global/1.setup :set_mimic_global setup :verify_on_exit! test &quot;invokes add from a task&quot; do Calculator |&gt; expect(:add, fn x, y -&gt; x + y end) Task.async(fn -&gt; assert Calculator.add(2, 3) == 5 end) |&gt; Task.await end","ref":"Mimic.html","title":"Mimic","type":"module"},{"doc":"Allow other processes to share expectations and stubs defined by another process.Arguments:module - the copied module.owner_pid - the process ID of the process which created the stub.allowed_pid - the process ID of the process which should also be allowed to use this stub.Raises:If Mimic is running in global mode.Allows other processes to share expectations and stubs defined by another process.Exampletest &quot;invokes add from a task&quot; do Caculator |&gt; expect(:add, fn x, y -&gt; x + y end) parent_pid = self() Task.async(fn -&gt; Calculator |&gt; allow(parent_pid, self()) assert Calculator.add(2, 3) == 5 end) |&gt; Task.await end","ref":"Mimic.html#allow/3","title":"Mimic.allow/3","type":"function"},{"doc":"Prepare module for mocking.Arguments:module - the name of the module to copy.","ref":"Mimic.html#copy/1","title":"Mimic.copy/1","type":"function"},{"doc":"Define a stub which must be called within an example.This function is almost identical to stub/3 except that the replacement function must be called within the lifetime of the calling pid (i.e. the test example).Arguments:module - the name of the module in which we're adding the stub.function_name - the name of the function we're stubbing.function - the function to use as a replacement.Raises:If module is not copied.If function_name is not publicly exported from module with the same arity.If function is not called by the stubbing process.Exampleiex&gt; Calculator.add(2, 4) 6 iex&gt; Mimic.expect(Calculator, :add, fn x, y -&gt; x * y end) ...&gt; Calculator.add(2, 4) 8","ref":"Mimic.html#expect/4","title":"Mimic.expect/4","type":"function"},{"doc":"Returns the current mode (:global or :private)","ref":"Mimic.html#mode/0","title":"Mimic.mode/0","type":"function"},{"doc":"Define a stub which must not be called.This function allows you do define a stub which must not be called during the course of this test. If it is called then the verification step will raise.Arguments:function - A capture of the function which must not be called.Raises:If function is not called by the stubbing process while calling verify!/1.Example:iex&gt; Mimic.reject(&amp;Calculator.add/2) Calculator","ref":"Mimic.html#reject/1","title":"Mimic.reject/1","type":"function"},{"doc":"Define a stub which must not be called.This function allows you do define a stub which must not be called during the course of this test. If it is called then the verification step will raise.Arguments:module - the name of the module in which we're adding the stub.function_name - the name of the function we're stubbing.arity - the arity of the function we're stubbing.Raises:If function is not called by the stubbing process while calling verify!/1.Example:iex&gt; Mimic.reject(Calculator, :add, 2) Calculator","ref":"Mimic.html#reject/3","title":"Mimic.reject/3","type":"function"},{"doc":"Chooses the mode based on ExUnit context. If async is true then the mode is private, otherwise global.setup :set_mimic_from_context","ref":"Mimic.html#set_mimic_from_context/1","title":"Mimic.set_mimic_from_context/1","type":"function"},{"doc":"Sets the mode to global. Mocks can be set and used by all processessetup :set_mimic_global","ref":"Mimic.html#set_mimic_global/1","title":"Mimic.set_mimic_global/1","type":"function"},{"doc":"Sets the mode to private. Mocks can be set and used by the processsetup :set_mimic_private","ref":"Mimic.html#set_mimic_private/1","title":"Mimic.set_mimic_private/1","type":"function"},{"doc":"Replace all public functions in module with stubs.The stubbed functions will raise if they are called.Arguments:module - The name of the module to stub.Raises:If module is not copied.If function is not called by the stubbing process.Exampleiex&gt; Mimic.stub(Calculator) ...&gt; Calculator.add(2, 4) ** (ArgumentError) Module Calculator has not been copied. See docs for Mimic.copy/1","ref":"Mimic.html#stub/1","title":"Mimic.stub/1","type":"function"},{"doc":"Define a stub function for a copied module.Arguments:module - the name of the module in which we're adding the stub.function_name - the name of the function we're stubbing.function - the function to use as a replacement.Raises:If module is not copied.If function_name is not publicly exported from module with the same arity.Exampleiex&gt; Calculator.add(2, 4) 6 iex&gt; Mimic.stub(Calculator, :add, fn x, y -&gt; x * y end) ...&gt; Calculator.add(2, 4) 8","ref":"Mimic.html#stub/3","title":"Mimic.stub/3","type":"function"},{"doc":"Verify if expectations were fulfilled for a process pid","ref":"Mimic.html#verify!/1","title":"Mimic.verify!/1","type":"function"},{"doc":"Verifies the current process after it exits.If you want to verify expectations for all tests, you can use verify_on_exit!/1 as a setup callback:setup :verify_on_exit!","ref":"Mimic.html#verify_on_exit!/1","title":"Mimic.verify_on_exit!/1","type":"function"},{"doc":"Abuse cover private functions to move stuff around.Completely based on meck's solution: https://github.com/eproxus/meck/blob/2c7ba603416e95401500d7e116c5a829cb558665/src/meck_cover.erl#L67-L91","ref":"Mimic.Cover.html","title":"Mimic.Cover","type":"module"},{"doc":"Stubs and expectations can be expressed in a more natural way.use Mimic.DSLtest &quot;basic example&quot; do stub Calculator.add(_x, _y), do: :stub expect Calculator.add(x, y), do: x + y expect Calculator.mult(x, y), do: x * y assert Calculator.add(2, 3) == 5 assert Calculator.mult(2, 3) == 6 assert Calculator.add(2, 3) == :stub endSupport for expecting multiple calls:expect Calculator.add(x, y), num_calls: 2 do x + y end","ref":"Mimic.DSL.html","title":"Mimic.DSL","type":"module"},{"doc":"","ref":"Mimic.DSL.html#expect/3","title":"Mimic.DSL.expect/3","type":"macro"},{"doc":"","ref":"Mimic.DSL.html#stub/2","title":"Mimic.DSL.stub/2","type":"macro"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;{}&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2012 Plataformatec Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"Mimic A sane way of using mocks in Elixir. It borrows a lot from both Meck &amp; Mox! Thanks @eproxus &amp; @josevalim.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Just add :mimic to your list of dependencies in mix.exs:def deps do [ {:mimic, &quot;~&gt; 1.5&quot;, only: :test} ] endIf :applications key is defined inside your mix.exs or you run mix test --no-start, you probably want to add Application.ensure_all_started(:mimic) in your test_helper.exs","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Modules need to be prepared so that they can be used.You must first call copy in your test_helper.exs for each module that may have the behaviour changed.Mimic.copy(Calculator) ExUnit.start()Calling copy will not change the behaviour of the module.The user must call stub/1, stub/3, expect/4 or reject/1 so that the functions can behave differently.Then for the actual tests one could use it like this:use ExUnit.Case, async: true use Mimic test &quot;invokes add once and mult twice&quot; do Calculator |&gt; stub(:add, fn x, y -&gt; :stub end) |&gt; expect(:add, fn x, y -&gt; x + y end) |&gt; expect(:mult, 2, fn x, y -&gt; x * y end) assert Calculator.add(2, 3) == 5 assert Calculator.mult(2, 3) == 6 assert Calculator.add(2, 3) == :stub end","ref":"readme.html#using","title":"Overview - Using","type":"extras"},{"doc":"Stubstub/1 will change every module function to throw an exception if called.stub(Calculator) ** (Mimic.UnexpectedCallError) Stub! Unexpected call to Calculator.add(3, 7) from #PID&lt;0.187.0&gt; code: assert Calculator.add(3, 7) == 10stub/3 changes a specific function to behave differently. If the function is not called no verification error will happen.Expectexpect/4 changes a specific function and it works like a queue of operations. It has precedence over stubs and if not called a verification error will be thrown.If the same function is called with expect/4 the order will be respected:Calculator |&gt; stub(:add, fn _x, _y -&gt; :stub end) |&gt; expect(:add, fn _, _ -&gt; :expected_1 end) |&gt; expect(:add, fn _, _ -&gt; :expected_2 end) assert Calculator.add(1, 1) == :expected_1 assert Calculator.add(1, 1) == :expected_2 assert Calculator.add(1, 1) == :stubexpect/4 has an optional parameter which is the amount of calls expected:Calculator |&gt; expect(:add, 2, fn x, y -&gt; {:add, x, y} end) assert Calculator.add(1, 3) == {:add, 1, 3} assert Calculator.add(4, 5) == {:add, 4, 5}With use Mimic, verification expect/4 function call of is done automatically on test case end. verify!/1 can be used in case custom verification timing required:Calculator |&gt; expect(:add, 2, fn x, y -&gt; {:add, x, y} end) # Will raise error because Calculator.add is not called # ** (Mimic.VerificationError) error while verifying mocks for #PID&lt;0.3182.0&gt;: # * expected Calculator.add/2 to be invoked 1 time(s) but it has been called 0 time(s) verify!()RejectOne may want to reject calls to a specific function. reject/1 can be used to achieved this behaviour.reject(&amp;Calculator.add/2) assert_raise Mimic.UnexpectedCallError, fn -&gt; Calculator.add(4, 2) end","ref":"readme.html#stub-expect-and-reject","title":"Overview - Stub, Expect and Reject","type":"extras"},{"doc":"The default mode is private which means that only the process and explicitly allowed process will see the different behaviour.Calling allow/2 will permit a different pid to call the stubs and expects from the original process.If you are using Task there is no need to use global mode as Tasks can see the same expectations and stubs from the calling process.Global mode can be used with set_mimic_global like this:setup :set_mimic_global test &quot;invokes add and mult&quot; do Calculator |&gt; expect(:add, fn x, y -&gt; x + y end) |&gt; expect(:mult, fn x, y -&gt; x * y end) parent_pid = self() spawn_link(fn -&gt; assert Calculator.add(2, 3) == 5 assert Calculator.mult(2, 3) == 6 send parent_pid, :ok end) assert_receive :ok endThis means that all processes will get the same behaviour defined with expect &amp; stub. This option is simpler but tests running concurrently will have undefined behaviour. It is important to run with async: false. One could use :set_mimic_from_context instead of using :set_mimic_global or :set_mimic_private. It will be private if async: true, global otherwise.","ref":"readme.html#private-and-global-mode","title":"Overview - Private and Global mode","type":"extras"},{"doc":"To use DSL Mode use Mimic.DSL rather than use Mimic in your test. DSL Mode enables a more expressive api to the Mimic functionality. use Mimic.DSL test &quot;basic example&quot; do stub Calculator.add(_x, _y), do: :stub expect Calculator.add(x, y), do: x + y expect Calculator.mult(x, y), do: x * y assert Calculator.add(2, 3) == 5 assert Calculator.mult(2, 3) == 6 assert Calculator.add(2, 3) == :stub end","ref":"readme.html#dsl-mode","title":"Overview - DSL Mode","type":"extras"},{"doc":"After calling Mimic.copy(MyModule), calls to functions belonging to this module will first go through an ETS table to check which pid sees what (stubs, expects or call original).It is really fast but it won't be as fast as calling a no-op function. Here's a very simple benchmark:defmodule Enumerator do def to_list(x, y), do: Enum.to_list(x..y) endBenchmarking Enumerator.to_list(1, 100) :Name ips average deviation median 99th % mimic 116.00 K 8.62 μs ±729.13% 5 μs 29 μs original 19.55 K 51.15 μs ±302.46% 34 μs 264 μs Comparison: mimic 116.00 K original 19.55 K - 5.93x slowerBenchmarking Enumerator.to_list(1, 250) :Name ips average deviation median 99th % original 131.49 K 7.61 μs ±167.90% 7 μs 16 μs mimic 105.47 K 9.48 μs ±145.21% 9 μs 27 μs Comparison: original 131.49 K mimic 105.47 K - 1.25x slowerThere's a small fixed price to pay when mimic is used but it is unnoticeable for tests purposes.","ref":"readme.html#implementation-details-performance","title":"Overview - Implementation Details &amp; Performance","type":"extras"},{"doc":"Thanks to @jamesotron and @alissonsales for all the help! :tada:","ref":"readme.html#acknowledgements","title":"Overview - Acknowledgements","type":"extras"},{"doc":"Copyright (c) 2016 Eduardo GurgelLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]